// dynamic_alocation_of_tensor_new.cpp
//
#ifdef _WIN32
	#pragma warning(disable:4996)
	#include <tchar.h>
	#include <windows.h>
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <string.h>
#include <iostream>
using namespace std;

#define MAXLINE 255
//#define MAXLEN 20    Nie je treba!

void my_getch();
void VypisTenzor(const unsigned, const unsigned, const unsigned, long double***);
void GetNamesOfIOFiles(const char[], char[]);
//---------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	int i, j, k, m, n, o;
	long double*** T;
	FILE* in;
	char nameoffile[MAXLINE];

	cout << "\n  Program nacita z textoveho suboru tenzor T a vypise ho"
		<< " na obrazovku.\n\n";

	GetNamesOfIOFiles("TENZOR.TXT", nameoffile);
	if ((in = fopen(nameoffile, "r")) == NULL) {
		cout << "  Subor TENZOR.TXT sa nepodarilo otvorit.\n";
		getch();
		return 1;
	}

	fscanf(in, "%i%i%i", &m, &n, &o);      // mnemotechnicka pomocka
	T = new long double** [m];          // pocet [] a * je 3
	for (i = 0; i < m; i++) {
		T[i] = new long double* [n];      // pocet [] a * je 3
		for (j = 0; j < n; j++)
			T[i][j] = new long double[o];  // pocet [] je 3
	}

	for (i = 0; i < m; i++)
		for (j = 0; j < n; j++)
			for (k = 0; k < o; k++)
				fscanf(in, "%Lf", &T[i][j][k]);

	cout << "  Z textoveho suboru bol nacitany tenzor T radu m x n x o = " << m 
		<< "x" << n << "x" << o << ":\n";
	VypisTenzor(m, n, o, T);

	for (i = 0; i < m; i++) { // Kazde new ma mat svoje delete
		for (j = 0; j < n; j++)
			delete[] T[i][j];
		delete[] T[i];
	}
	delete[] T;

	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
// Tenzor ako parameter funkcie volame odkazom "by dereference"
void VypisTenzor(const unsigned m, const unsigned n, const unsigned o, 
	long double*** X)
{
	unsigned i, j, k;

	for (i = 0; i < m; i++) {
		cout << "\n  m = " << i + 1 << ":\n";
		for (j = 0; j < n; j++) {
			for (k = 0; k < o; k++)
				printf("%12.6Lf", X[i][j][k]);
			cout << "\n";
		}
	}
}
//---------------------------------------------------------------------------
void GetNamesOfIOFiles(const char name_of_input_file[], char path_to_input_file[])
{
	char current_path[MAXLINE];
	current_path[0] = '\0';

#ifdef _WIN32
	TCHAR exePath[MAXLINE];

	HMODULE hModule = GetModuleHandle(NULL);
	if (hModule != NULL) {
		if (!GetModuleFileName(hModule, exePath, MAXLINE)) {
			cout << "Nepodarila sa zistit cesta k exe-suboru.\n";
			my_getch();
			exit(1);
		}
	}
	else {
		cout << "Module handle is NULL.\n" << endl;
		my_getch();
		exit(1);
	}

	int iii;
	bool flag = false;
	for (iii = (int)wcslen(exePath); iii >= 0; iii--) {
		if (!flag && exePath[iii] == '\\') {
			current_path[iii + 1] = '\0';
			flag = true;
		}
		if (flag)
			current_path[iii] = (char)exePath[iii];
	}
#elif (defined __linux__) || (defined __APPLE__)
	unsigned iii;
	char line[MAXLINE];
	FILE* fp;
	if ((fp = popen("/bin/pwd", "r")) == NULL) {
		perror("popen error");
		exit(1);
	}
	if (fgets(line, MAXLINE, fp) == NULL) {
		perror("fgets error");
		exit(1);
	}
	pclose(fp);

	iii = 0;
	while (line[iii] != '\r' && line[iii] != '\n') {
		current_path[iii] = line[iii];
		iii++;
	}
	current_path[iii] = '\0';
#elif (defined _AIX)
	unsigned iii;
	char line[MAXLINE];
	FILE* fp;
	if ((fp = popen("user/bin/pwd", "r")) == NULL) {
		perror("popen error");
		exit(1);
	}
	if (fgets(line, MAXLINE, fp) == NULL) {
		perror("fgets error");
		exit(1);
	}
	pclose(fp);

	iii = 0;
	while (line[iii] != '\r' && line[iii] != '\n') {
		current_path[iii] = line[iii];
		iii++;
	}
	current_path[iii] = '\0';
#endif

	path_to_input_file[0] = '\0';
	strcat(path_to_input_file, current_path);
#if (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	strcat(path_to_input_file, "/inputs/");
#elif (defined _WIN32)
	strcat(path_to_input_file, "inputs\\");
#endif
	strcat(path_to_input_file, name_of_input_file);
}
//---------------------------------------------------------------------------
